#ifndef _IOO_
#define _IOO_

#ifndef PLUGIN_LOADER

#include <poppler.h>

#include "../gloobus-preview-interface-document.h"

class iOO : public iDocument
{
	
	public:
								iOO			( void );
	virtual	int					get_n_pages		( void );
	virtual int					get_page_width  ( void );
	virtual int					get_page_height ( void );
	virtual GdkPixbuf*			get_page_pixbuf ( int n_page );
	virtual GtkWidget*          get_page        ( int );
	virtual	void				end_plugin 		( void );

	int							get_page_height_unscaled	( void );
	int							get_page_width_unscaled		( void );

	bool						load_doc  		( void );

	private:

	void						get_scale ( void );

	PopplerDocument 			*m_document;
  	PopplerPage 				*m_page;
	double 						m_scale;
  	
  	void						convert_to_pdf	( void );
			

};


extern "C" interface * create() {
	return new iOO;
}

extern "C" void destroy(interface * p) {
	delete (iOO*)p;
}

extern "C" int getVersion() {
	return MANAGER_VERSION;
}

#endif

#ifdef PLUGIN_LOADER

//PluginManager::register_plugin("openoffice");

#endif

#endif

