#ifndef _IPS_
#define _IPS_

#ifndef PLUGIN_LOADER

#include <libspectre/spectre.h>

//#include "../gloobus-preview-plugin-manager.h"
#include "../gloobus-preview-interface-document.h"

class iPs : public iDocument
{
	private:
		SpectreDocument *p_document;
		gint             p_page_width;
		gint             p_page_height;
		gdouble          p_page_scale;

	public:
		iPs ( void );
		virtual ~iPs ( void );
		virtual	int get_n_pages ( void );
		virtual int get_page_width ( void );
		virtual int get_page_height ( void );
		virtual GdkPixbuf* get_page_pixbuf ( int n_page );
		virtual GtkWidget* get_page ( int );
		virtual	void end_plugin ( void );

		int get_page_height_unscaled ( void );
		int get_page_width_unscaled ( void );
		static void ps_free(guchar*, void*);
		bool load_doc ( void );

	private:
		void get_page_size (gint, int*, int*);
		void get_page_scale ( void );
};

extern "C" interface * create() {
    return new iPs;
}

extern "C" void destroy(interface * p) {
    delete (iPs*)p;
}

extern "C" int getVersion() {
	return MANAGER_VERSION;
}

#endif

#ifdef PLUGIN_LOADER

PluginManager::register_plugin("ps");

PluginManager::register_filetype("application/postscript", 1);
PluginManager::register_filetype("application/x-bzpostscript", 1);
PluginManager::register_filetype("application/x-gzpostscript", 1);
PluginManager::register_filetype("image/x-eps", 1);
PluginManager::register_filetype("image/x-bzeps", 1);
PluginManager::register_filetype("image/x-gzeps", 1);

#endif

#endif

